package chat

import (
	"context"
	"errors"
	"fmt"

	"wechat-api/internal/svc"
	"wechat-api/internal/types"
	"wechat-api/internal/utils/compapi"
	"wechat-api/internal/utils/contextkey"

	"github.com/zeromicro/go-zero/core/logx"
)

type ChatCompletionsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewChatCompletionsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ChatCompletionsLogic {
	return &ChatCompletionsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx}
}

func (l *ChatCompletionsLogic) ChatCompletions(req *types.CompApiReq) (resp *types.CompOpenApiResp, err error) {
	// todo: add your logic here and delete this line

	/*
	   1.鉴权获得token
	   2.必要参数检测及转换
	   3. 根据event_type选择不同处理路由
	*/
	var (
		authToken string
		ok        bool
	)
	authToken, ok = contextkey.OpenapiTokenKey.GetValue(l.ctx)
	if !ok {
		return nil, errors.New("content get token err")
	}
	fmt.Printf("In ChatCompletionsLogic.ChatCompletions AuthToken:%v\n", authToken)

	return l.workForFastgpt(req)
}

func (l *ChatCompletionsLogic) workForFastgpt(req *types.CompApiReq) (resp *types.CompOpenApiResp, err error) {

	apiKey := "fastgpt-d2uehCb2T40h9chNGjf4bpFrVKmMkCFPbrjfVLZ6DAL2zzqzOFJWP"
	return compapi.NewFastgptChatCompletions(l.ctx, apiKey, req)

}
